package com.mugil.org.controllers;

import com.mugil.org.services.EmpServiceImpl;
import com.mugil.org.models.Employee;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@Controller
@RequestMapping(value = "/employees")
public class EmployeeController {

    @Autowired
    EmpServiceImpl empServiceImpl;


    @GetMapping(value = "/all")
    public @ResponseBody List<Employee> listAllEmployees() {
        return empServiceImpl.getEmployees();
    }

    @RequestMapping(value = "/empId", method = RequestMethod.GET)
    public @ResponseBody List<Employee> getEmpById(String empId) {
         List<Employee> arrEmp = empServiceImpl.getEmployees();
        List<Employee> arrEmpFilter = new ArrayList<>();

        for (int i=0;i<arrEmp.size();i++)
        {
            Employee  objEmp = arrEmp.get(i);

            if(objEmp.getEmpId().equals(empId))
                arrEmpFilter.add(arrEmp.get(i));
        }

        return arrEmpFilter;
    }


    @PostMapping(value = "/")
    public @ResponseBody void createEmployee(@RequestBody Employee emp) {
        empServiceImpl.addEmployeeList(emp);
    }


    @PutMapping("/{EmpId}")
    public @ResponseBody void updateEmployee(@RequestBody Employee emp, @PathVariable("EmpId") String pEmpId) {
        empServiceImpl.updateEmpDetails(emp, pEmpId);
    }

    @GetMapping(value="/{EmpId}", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Employee getEmployee(@PathVariable("EmpId") String pEmpId) {
        return empServiceImpl.getEmployeeById(pEmpId);
    }

    @DeleteMapping(value="/{EmpId}")
    public @ResponseBody String deleteUser(@PathVariable("EmpId") String pEmpId) {
        return  empServiceImpl.deleteEmployeeById(pEmpId);
    }

}
