package com.mugil.org.repository;

import com.mugil.org.models.Employee;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;

@Component
public class EmployeeDB {
    public List<Employee> arrEmployee = new ArrayList<>();

    public EmployeeDB(){
        arrEmployee.add(new Employee("101", "Mugil"));
    }

    public List getEmployeesFromDB() {
        return arrEmployee;
    }

    public List addEmployeetoDB(Employee employee)
    {
        arrEmployee.add(employee);
        return arrEmployee;
    }

    public boolean updateEmployeeInDB(Employee emp, String pEmpId){
        Predicate<Employee> byId = employee -> employee.getEmpId().equals(pEmpId);

        if(byId != null) {
            Employee result = arrEmployee.stream().filter(byId).findFirst().get();
            result.setName(emp.getName());
            return true;
        }

        return false;
    }

    public Employee getEmployeeByIdFromDB(String pEmpId){
        Predicate<Employee> byId = employee -> employee.getEmpId().equals(pEmpId);
        Employee result = arrEmployee.stream().filter(byId).findFirst().get();
        return result;
    }

    public Boolean deleteEmployeeByIdFromDB(String pEmpId){
        if(arrEmployee.removeIf(employee -> employee.getEmpId().equals(pEmpId)))
            return true;
        else
            return false;
    }
}
